var MindMeister = new Object();

// The main site name and URLs
MindMeister.refreshURLs = function(acc, pwd) {
    // check if (local) demo mode
    if ((acc=="mhollauf" || acc=="tvollmer") && pwd=="qqqqq") {
        MindMeister.siteName = "localhost:3000";
        var local = true;
    } else {
        MindMeister.siteName = "www.mindmeister.com";
    }
    var protocol = (local ? 'http://' : 'https://');
    // The base URL to open.
    MindMeister.baseUrl = protocol + MindMeister.siteName;
    // The authentication URL.
    MindMeister.authUrl = protocol + MindMeister.siteName + '/account/client_login';
    // The insert URL.
    MindMeister.insertUrl = protocol + MindMeister.siteName + '/maps/client_insert';
};

// Try to authenticate the user.
MindMeister.authenticate = function(callback) {
    var account = Prefs.getAccount();
    var password = Prefs.getPassword(account);
    MindMeister.refreshURLs(account, password);

    var request = new XMLHttpRequest();
    request.onload = function(e) { callback(e, request); };
    request.overrideMimeType("text/plain");
    request.open("POST", MindMeister.authUrl);
    request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    request.setRequestHeader("Cache-Control", "no-cache");
    request.setRequestHeader("Accept", "text/xml");

    var params = "login=" + encodeURI(account) + "&password=" + encodeURI(password);

    request.send(params);
};

MindMeister.insert = function(callback, ideaString) {
    var account = Prefs.getAccount();
    var password = Prefs.getPassword(account);
    MindMeister.refreshURLs(account, password);

    var request = new XMLHttpRequest();
    request.onload = function(e) { callback(e, request); };
    request.overrideMimeType("text/plain");
    request.open("POST", MindMeister.insertUrl);
    request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    request.setRequestHeader("Cache-Control", "no-cache");
    request.setRequestHeader("Accept", "text/xml");

    var params = "login=" + encodeURI(account) + "&password=" + encodeURI(password)
        + "&client=simple&title=" + encodeURI(ideaString);

    request.send(params);
};

MindMeister.checkResponse = function(e, request) {
    var response = request.responseText;
    //alert(response);
    if (response == null) {
        return "Couldn't connect";
    } else if (response.indexOf("Error=badauth") >= 0) {
        Prefs.setPassword(Prefs.getAccount(), null);
        return "Login failed";
    } else if (response.indexOf("Error=nomap") >= 0) {
        return "No default map set";
    } else if (response.indexOf("Error=noaccess") >= 0) {
        return "No write access";
    } else if (response.indexOf("OK") < 0 && response.indexOf('success":true') < 0) {
        return "General Error";
    } else {
        return true;
    }
};

